#ifndef GENERATOR_H
#define GENERATOR_H

#include <functional>
#include <stdint.h>
#include <vector>

class Program;
class GenImpl;

typedef std::function<bool(const Program&)> GenCallback;

void generate(uint32_t size, uint32_t usedOps, const GenCallback& callback);

typedef uint64_t count_t;

class Generator
{
public:
    Generator();
    ~Generator();
    void init(uint32_t sizeIn, uint32_t usedOpsIn);
    count_t getCount();
    void generate(const GenCallback& callback);

private:
    GenImpl *m_pImpl;
};

#endif
