#ifndef PROBLEM_H
#define PROBLEM_H

#include <string>

namespace UsedOp
{
    enum Enum
    {
        Not = 1 << 0,
        Shl1 = 1 << 1,
        Shr1 = 1 << 2,
        Shr4 = 1 << 3,
        Shr16 = 1 << 4,
        And = 1 << 5,
        Or = 1 << 6,
        Xor = 1 << 7,
        Plus = 1 << 8,
        If0 = 1 << 9,
        TFold = 1 << 10,
        Fold = 1 << 11,
        Bonus = 1 << 12,
    };
}

enum class ProblemSolved : uint32_t
{
    Unspecified,
    False,
    True
};

class Problem
{
public:
    Problem() : m_size(0), m_usedOps(0), m_solved(ProblemSolved::Unspecified) {}
    std::string m_id;
    uint32_t m_size;
    uint32_t m_usedOps;
    ProblemSolved m_solved;
};

#endif
