#ifndef PROGRAM_H
#define PROGRAM_H

#include <stdint.h>
#include <string>

enum class Op : uint32_t
{
    Zero,
    One,
    X,
    Y,
    Z,
    Not,
    Shl1,
    Shr1,
    Shr4,
    Shr16,
    And,
    Or,
    Xor,
    Plus,
    If0,
    Fold,
};

class Program
{
public:
    Program() : m_opEnd(0), m_foldOpEnd(0) {}
    uint64_t eval(uint64_t input) const;
    std::string toString() const;
    void pack(uint64_t* data) const;
    void unpack(const uint64_t* data);

    Op m_ops[50];
    uint32_t m_opEnd;
    uint32_t m_foldOpEnd;
};

#endif
