#include "Program.hpp"
#include "Problem.hpp"
#include "Protocol.hpp"
#include "Generator.hpp"
#include "Solver.hpp"
#include <stdio.h>
#define __STDC_FORMAT_MACROS
#include <inttypes.h>
#include <vector>
#include <string>

using std::vector;
using std::string;

int main(int argc, char *argv[])
{
    Protocol::init();

#if 0
    printf("Hello, world!\n");

    Program program;
    program.m_ops[0] = Op::X;
    program.m_ops[1] = Op::Zero;
    program.m_ops[2] = Op::Fold;
    program.m_opEnd = 3;
    program.m_ops[3] = Op::Z;
    program.m_ops[4] = Op::Shl1;
    program.m_ops[5] = Op::Shl1;
    program.m_ops[6] = Op::Shl1;
    program.m_ops[7] = Op::Shl1;
    program.m_ops[8] = Op::Y;
    program.m_ops[9] = Op::Or;
    program.m_foldOpEnd = 10;

    program.m_ops[0] = Op::X;
    program.m_ops[1] = Op::Zero;
    program.m_ops[2] = Op::One;
    program.m_ops[3] = Op::If0;
    program.m_opEnd = 4;
    program.m_foldOpEnd = 4;

    uint64_t in = 0x0807060504030201;
    uint64_t out = program.eval(in);

    printf("in = 0x%016"PRIx64", out = 0x%016"PRIx64"\n", in, out);

    printf("%s\n", program.toString().c_str());

    printf("\n");
#endif

#if 0
    uint64_t count = 0;
    auto callback = [&count](const Program& program) -> bool {
        //uint64_t iProgram = count;
        count++;

        //printf("%s\n", program.toString().c_str());
        //program.eval(0x0123456789abcdef);
        uint64_t result = program.eval(0x0123456789abcdef);
        printf("0x%016"PRIx64" %s\n", result, program.toString().c_str());
        return true;
    };

    generate(3, callback);

    printf("count = %"PRIu64"\n", count);
#endif

#if 0
    generate(3);

    printf("count = %"PRIu64"\n", count);
#endif

    string msg;

#if 0
    vector<Problem> problems;
    if (!Protocol::loadProblems("../data/myproblems.json", &problems, &msg))
    {
        printf("Error loading problems: %s\n", msg.c_str());
        return 1;
    }

    uint32_t problemCount = (uint32_t)problems.size();
    printf("problemCount = %"PRIu32"\n", problemCount);
#endif

#if 0
    for (uint32_t iProblem = 0; iProblem < problemCount; iProblem++)
    {
        const Problem& problem = problems[iProblem];
        printf("%s, %2"PRIu32", 0x%04"PRIx32"\n",
               problem.m_id.c_str(),
               problem.m_size,
               problem.m_usedOps);
    }
#endif

#if 0
    string strProg("(lambda (x) (fold x 0 (lambda (y z) (or (shl1 (shl1 (shl1 (shl1 z)))) y))))");
    vector<uint64_t> args;
    args.push_back(0x0807060504030201);
    args.push_back(0x0123456789abcdef);
    vector<uint64_t> outputs;
    if (!Protocol::evalProg(strProg, args, &outputs, &msg))
    {
        printf("evalProg failed: %s\n", msg.c_str());
    }

    printf("Outputs: ");
    uint32_t outputCount = (uint32_t)outputs.size();
    for (uint32_t iOutput = 0; iOutput < outputCount; iOutput++)
    {
        if (iOutput != 0)
        {
            printf(", ");
        }

        uint64_t output = outputs[iOutput];
        printf("0x%016"PRIx64"", output);
    }
    printf("\n");
#endif

#if 0
    Problem problem;
    string challenge;
    if (!Protocol::train(4, TrainOps::None, &problem, &challenge, &msg))
    {
        printf("train failed: %s\n", msg.c_str());
    }

    printf("Challenge: %s\n", challenge.c_str());
    printf("%s, %2"PRIu32", 0x%04"PRIx32"\n",
           problem.m_id.c_str(),
           problem.m_size,
           problem.m_usedOps);

    if (!solve(problem))
    {
        return 1;
    }

#endif

    return 0;
}
